class DotStraightTail implements Shape {
  color dColor;
  boolean dIsHollow;
  float dFatness; //0-1
  int minXSize, minYSize, maxXSize, maxYSize;

  //Dot
  DotStraightTail() {
    dIsHollow = false;
    dFatness = 0.1;
  } //Dot

  //updateDraw with buffer
  @Override
    void updateDraw(int dOriginX, int dOriginY, int dWidth, int dHeight, PGraphics buffer) {
    dColor = getDotColor();

    buffer.ellipseMode(LEFT);

    buffer.pushMatrix();
    buffer.translate(dOriginX, dOriginY);

    if (showRects) {
      buffer.fill(120, 80, 0);
      buffer.stroke(0);
      buffer.rect(0, 0, dWidth, dHeight);
    }

    buffer.strokeWeight = 1.0;

    //tail
    int requiredEllipses = int((dWidth / (dHeight / 4.0)) * 4);
    for (int i=0; i<requiredEllipses; i++) {
      buffer.noStroke();
      buffer.fill(dColor);

      float divisor = 4.0;
      if (dFatness <= 0) {
        divisor = 4.0;
      } 
      else {
        divisor = ((pow(float(i) / requiredEllipses, 1.0/max(0.01, 1.0 - dFatness))) * 3.0 + 1); //should be 1.0 - 4.0
      }
      float dSize = dHeight / divisor;
      float dSizeHalf = dSize / 2.0;
      float xPosition = (float(i) / float(requiredEllipses)) * (dWidth - dSize); 

      buffer.ellipse(xPosition, (dHeight / 2.0) - dSizeHalf, dSize, dSize);
    }


    //main dot
    buffer.noStroke();
    buffer.fill(dColor);
    buffer.ellipse(0, 0, dHeight, dHeight);

    if (dIsHollow) {
      buffer.fill(bgColor);
      float scaler = 0.55;
      buffer.ellipse(0 + (((1.0 - scaler) / 2.0) * dHeight), 0 + (((1.0 - scaler) / 2.0) * dHeight), dHeight * scaler, dHeight * scaler);
    } 
    buffer.popMatrix();
  } //updateDraw with buffer

  void setSizes(int minX, int minY, int maxX, int maxY) {
    minXSize = minX;
    minYSize = minY;
    maxXSize = maxX;
    maxYSize = maxY;
  }
  int minXSize() {
    return minXSize;
  }
  int minYSize() {
    return minYSize;
  }
  int maxXSize() {
    return maxXSize;
  }
  int maxYSize() {
    return maxYSize;
  }
}
